﻿package game{
	import flash.ui.Keyboard;
	import flash.display.MovieClip;
	class MyShip extends Unit {
		const MIN_X:int = 40;
		const MAX_X:int = 280;
		var speed:int;
		var rotation:int;
		var life:int;
		private var _rightFlag:Boolean;
		private var _leftFlag:Boolean;
		private var _shotFlag:Boolean;
		function MyShip(newX:int, newY:int, newSpeed:int):void {
			var disp:MovieClip = new HiyokoBody();
			super(disp, newX, newY);
			speed = newSpeed;
			life = 50;
			_rightFlag = false;
			_leftFlag = false;
			_shotFlag = false;
		}
		function setKeyFlag(key:uint, flag:Boolean):void {
			if (key == Keyboard.RIGHT) {
				_rightFlag = flag;
			} else if (key == Keyboard.LEFT) {
				_leftFlag = flag;
			} else if (key == Keyboard.SPACE) {
				_shotFlag = flag;
			}
		}
		override function action():void {
			if (_rightFlag) {
				rotation = 20;
				x += speed;
				if (x>MAX_X) x = MAX_X;
			} else if (_leftFlag) {;
				rotation = -20;
				x -= speed;
				if (x<MIN_X)x= MIN_X;
			} else {
				rotation = 0;
			}
			if(_shotFlag){
				var mainGame:MainGame = body.parent as MainGame;
				mainGame.addBullet();
			}
		}
		override function draw():void {
			super.draw();
			body.rotation = rotation;
		}
		function setDamage(damage:int):void{
			life -= damage;
			if(life<=0){
				var mainGame:MainGame = body.parent as MainGame;
				mainGame.gameOver();
			}
		}
	}
}